<?php

	/**
	* Plugin Name: CF7 Event Tracker
	* Plugin URI: https://www.codepalm.de
	* Description: Contact Form 7 Event Tracker
	* Version: 0.0.0
	* Author: Dennis Artinger
	* Author URI: https://www.codepalm.de
	* License: GPL2
	* License URI:  https://www.gnu.org/licenses/gpl-2.0.html
	* Text Domain:  cf7-event-tracker
	* Domain Path: /languages
	*/

	namespace CF7EventTracker;

	use \CF7EventTracker\PluginLoader	as PluginLoader;
	use \CF7EventTracker\Debug			as Debug;


	defined( 'ABSPATH' ) or die( "No Script Kiddies, please" );
	

	// Declare neccessary Constants
	if( !defined( 'CF7ET_DOMAIN' ) ) {

		define( 'CF7ET_DOMAIN', dirname( \plugin_basename( __FILE__ ) ) );
		define( 'CF7ET_PATH', \plugin_dir_path( __FILE__ ) );
		define( 'CF7ET_URL', \plugin_dir_url( __FILE__ ) );
		define( 'CF7ET_INDEX', __FILE__ );
		define( 'CF7ET_BLOGID', \get_current_blog_id() );

	}

	// Define Debugger
	require_once( CF7ET_PATH . '/inc/global/Debug.php' );
    $debugger = new Debug();
	$debugger->init_debugger();

	// Start Main-Algorithm (ToDo: Outsource)
	$cf7et = new Main();
	$cf7et->register_hooks();
	class Main {

		function __construct() {
			
			Debug::add_msg( 'Create Main-Class of CF7-Event-Tracker', __FUNCTION__, __CLASS__ );
			$this->load_files();

		}

		protected function load_files() {

			Debug::add_msg( 'Insert File Loader and Init', __FUNCTION__, __CLASS__ );

			if( !class_exists( '\CPPluginCore\Loader' ) ) {

				require_once( CF7ET_PATH . 'vendor/codepalm/wp-plugin-core/inc/loader/Loader.php' );

			}

			require_once( CF7ET_PATH . 'inc/global/loader/PluginLoader.php' );
			$loader = new PluginLoader( CF7ET_PATH, CF7ET_URL );
			$loader->init_loader();

		}

		public function register_hooks() {

			Debug::add_msg( 'Add Actions', __FUNCTION__, __CLASS__ );
			\add_action( 'plugins_loaded', array( $this, 'load_plugin_textdomain' ) );

		}

		public function load_plugin_textdomain() {

			Debug::add_msg( 'Load Text-Domain', __FUNCTION__, __CLASS__ );
			\load_plugin_textdomain( CF7ET_DOMAIN, false, CF7ET_PATH . 'languages/' );

		}

		public static function cf7_exists() {
				
			Debug::add_msg( 'Check if CF7 Exists', __FUNCTION__, __CLASS__ );

			require_once ABSPATH . 'wp-admin/includes/plugin.php';

			$cf7_exists = false;
			if( function_exists( 'get_plugins' ) ) {
				foreach( \get_plugins() as $key => $plugin ) {
					if( $plugin[ 'TextDomain' ] == 'contact-form-7' ) {
						if( \is_plugin_active( $key ) )
							$cf7_exists = true;
						else 
							$cf7_exists = false;
					}
				}
			}
			
			return $cf7_exists;
			
		}

	}

?>