<?php

    namespace CF7EventTracker;

    use \CF7EventTracker\InputField         as InputField;

    class Fieldsets {

        function __construct() {
            
            $this->load_dependencies();

        }

        private function load_dependencies() {

            require_once( CF7ET_PATH . "inc/global/backend/fields/InputField.php" );

        }

        public function get_google_analytics_fields( $id, $val, $is_cf7_form=false ) {

            ob_start();
            ?>
                <h5><?php echo _x( 'Google Analytics', 'Forms Title', 'cf7-event-tracker' ); ?></h5>
            <?php
    
            $fields = array(
                array(
                    'name'      => 'id',
                    'group'     => 'cf7',
                    'type'      => 'input',
                    'list'      => 'cf7_forms_list',
                    'readonly'  => $is_cf7_form,
                    'desc'      => array(
                        'placeholder'   => _x( 'CF7 ID', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Contact Form 7 ID', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Paste the ID of your form from Contact Form 7 in this field.<br/>Delete this value, if you want to delete the entire Tracking.<br/><strong>Caution:</strong> All data for this form will be deleted. The data will also be deleted, if you place an invalid ID.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'  => 'campaign',
                    'group' => 'analytics',
                    'type'  => 'input',
                    'desc'      => array(
                        'placeholder'   => _x( 'GA Campaign', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Google Analytics Campaign', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Enter the campaign of your Google Analytics event here.<br/>This field is required for the use of Google Analytics.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'  => 'action',
                    'group' => 'analytics',
                    'type'  => 'input',
                    'desc'      => array(
                        'placeholder'   => _x( 'GA Action', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Google Analytics Action', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Enter the action of your Google Analytics event here.<br/>This field is required for the use of Google Analytics.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'  => 'label',
                    'group' => 'analytics',
                    'type'  => 'input',
                    'desc'      => array(
                        'placeholder'   => _x( 'GA Label', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Google Analytics Label', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Enter the label of your Google Analytics event here.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'  => 'value',
                    'group' => 'analytics',
                    'type'  => 'input',
                    'desc'      => array(
                        'placeholder'   => _x( 'GA Value', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Google Analytics Value', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Enter the value of your Google Analytics event here.', 'Forms Content', 'cf7-event-tracker' )
                    )
                )
            );
    
            $this->render_fields( $id, $val, $fields );
    
            return ob_get_clean();
    
        }
    
        public function get_hubspot_fields( $id, $val ) {
    
            ob_start();
            ?>
                <h5><?php echo _x( 'Hubspot', 'Forms Title', 'cf7-event-tracker' ); ?></h5>
            <?php
    
            $fields = array(
                array(
                    'name'      => 'activated',
                    'group'     => 'hubspot',
                    'type'      => 'checkbox',
                    'desc'      => array(
                        'placeholder'   => _x( 'Create hubspot ticket on request', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Hubspot Ticket', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Enabling this feature will create a ticket in Hubspot from your contact form requests.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'subject',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'HubSpot Ticket Title', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'HubSpot Ticket Title', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Set your own Title for the Hubspot-Tickets with the following placeholders:', 'Forms Content', 'cf7-event-tracker' ) .
                            "<ul>".
                                "<li>".
                                    "<strong>%DATE%</strong>:<br/>".
                                    _x( 'Replace "DATE" with one of the following Date-Codes to set the current Date:<br/><b>MM/DD/YYYY</b><br/><b>DD/MM/YYYY</b><br/><b>DD.MM.YYYY</b><br/><b>YYYY-MM-DD</b>', 'Forms Label', 'cf7-event-tracker' ).
                                "</li>".
                                "<li>".
                                    "<strong>%BLOGNAME%</strong>:<br/>".
                                    _x( 'Name of your Website/Blog (Settings > General)', 'Forms Label', 'cf7-event-tracker' ).
                                "</li>".
                                "<li>".
                                    "<strong>%FORMTITLE%</strong>:<br/>".
                                    _x( 'Title of the Contact Form 7 Form', 'Forms Label', 'cf7-event-tracker' ).
                                "</li>".
                                "<li>".
                                    "<strong>[CF7-FIELD]</strong>:<br/>".
                                    _x( 'Change "CF7-FIELD" to the slug of a Contact Form 7 field.<br/>Example: <b>[your-subject]</b> or <b>[your-name]</b>', 'Forms Label', 'cf7-event-tracker' ).
                                "</li>".
                            "</ul>"
                    )
                ),
                array(
                    'name'      => 'message',
                    'group'     => 'hubspot',
                    'type'      => 'textarea',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Hubspot Ticket Data', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Hubspot Ticket Data', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'This Data will be pulled to Hubspot. You can use the same placeholders as in the Ticket-Title.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'hs_customer_headline',
                    'group'     => 'hubspot',
                    'type'      => 'headline',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'title'         => _x( 'Customer Settings', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Create Customer-Entry if your visitor is sending a contact request.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'create-customer',
                    'group'     => 'hubspot',
                    'type'      => 'checkbox',
                    'desc'      => array(
                        'placeholder'   => _x( 'Create hubspot customer on request', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Hubspot Customer', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Enabling this feature will create automatically a new customer in HubSpot.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-firstname',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer Firstname', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer Firstname', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The firstname of your visitor. You can set "[your-name]", if you are using standard-identifiers of Contact Form 7.<br/>Please note, that the standard contact form doesn\'t differentiate between firstname and lastname.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-lastname',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer Lastname', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer Lastname', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The lastname of your visitor. You can set a new input field "[your-lastname]" in your contact form.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-email',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer E-Mail', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer E-Mail', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The email address of your visitor. Contact Form 7 will use the field "[your-email]" for the visitors mail address.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-website',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer Website', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer Website', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The website of your viewer. You can add a new field "[your-website]" to your contact form.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-company',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer Company', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer Company', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The company of your visitor. Please note, that your visitors mustn\'t be from a company. You should\'t set this field as "required".', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-phone',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer Phone', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer Phone', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The phone number of your visitor, if you need this data. You must add a new field "[your-phone]" to your contact form.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-address',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer Address', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer Address', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The street name and house number of your visitor. You must add a new field "[your-street]" to your contact form.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-city',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer City', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer City', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The city name of your visitor. You must add a new field "[your-city]" to your contact form.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-state',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer State', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer State', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The state name of your visitor. You must add a new field "[your-state]" to your contact form.', 'Forms Content', 'cf7-event-tracker' )
                    )
                ),
                array(
                    'name'      => 'customer-zip',
                    'group'     => 'hubspot',
                    'type'      => 'input',
                    'list'      => 'cf7_tag_list_'.$val[ 'cf7' ][ 'id' ],
                    'desc'      => array(
                        'placeholder'   => _x( 'Customer ZIP', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Customer ZIP', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'The postal code of your visitor. You must add a new field "[your-zip]" to your contact form.', 'Forms Content', 'cf7-event-tracker' )
                    )
                )
            );
    
            $this->render_fields( $id, $val, $fields );
    
            return ob_get_clean();
    
        }
    
        public function get_custom_js_fields( $id, $val ) {
    
            ob_start();
            ?>
                <h5><?php echo _x( 'Custom JavaScript', 'Forms Title', 'cf7-event-tracker' ); ?></h5>
            <?php
    
            $fields = array(
                array(
                    'name'  => 'script',
                    'group' => 'js',
                    'type'  => 'textarea',
                    'desc'      => array(
                        'placeholder'   => _x( 'JavaScript after request (Optional)', 'Forms Label', 'cf7-event-tracker' ),
                        'title'         => _x( 'Custom JavaScript', 'Forms Title', 'cf7-event-tracker' ),
                        'description'   => _x( 'Here you can add a custom JavaScript that will fire after a request has been sent.', 'Forms Content', 'cf7-event-tracker' )
                    )
                )
            );
    
            $this->render_fields( $id, $val, $fields );
            
            return ob_get_clean();
    
        }
    
        public function get_tracking_chart( $id, $val, $settings ) {
    
            $system_tracking = ( $settings[ 'tracking' ] == 'activated' );
            if( $system_tracking && !empty( $val ) && $val[ 'cf7' ][ 'id' ] != -1 || $system_tracking && $id != -1 ) {
                
                if( !empty( $val ) && !array_key_exists( 'tracking', $val ) || empty( $val[ 'tracking' ] ) )
                    return _x( 'There isn\'t any data yet that can be displayed', 'Message Info', 'cf7-event-tracker' );
    
                $tracking_data = $val[ 'tracking' ][ 'internal' ];
    
                /* Get Chart Data */
                $chart_data = "";
                $dates = array();
                foreach( $tracking_data as $tracking ) {
                    if( !array_key_exists( date( 'Ymd', $tracking[ 'time' ] ), $dates ) )
                        $dates[ date( 'Ymd', $tracking[ 'time' ] ) ] = 1;
                    else 
                        $dates[ date( 'Ymd', $tracking[ 'time' ] ) ] += 1;
                }
                
                for( $i=29; $i>=0; $i-- ) {
                    $date = date( 'Ymd', strtotime( '-' . $i . ' days' ) );
                    $current = 0;
                    if( array_key_exists( $date, $dates ) )
                        $current = $dates[ $date ];
                    
                    $chart_data .= '"'.$current.'",';
                }
                /* Get Chart Data - End */
                
                /* Get Chart Dates */
                $chart_dates = "";
                for( $i=29; $i>=0; $i-- ) {
                    $chart_dates .= '"'.date( 'd.m.Y', strtotime( '-' . $i . ' days' ) ).'",';
                }
                /* Get Chart Dates - End */
                
                ob_start();
                ?>
                    <h5><?php echo _x( 'Inquiries of the last 30 days', 'Forms Title', 'cf7-event-tracker' ); ?></h5>
                    <div id="chart_<?php echo $id; ?>" style="width:calc( 100% - 62px ); height:200px;"></div>
                    <script type="text/javascript">
                        /* https://www.echartsjs.com/examples/en/ */
                        var myChart = echarts.init( document.getElementById( 'chart_<?php echo $id; ?>' ) );
    
                        var option = {
                            grid: {
                                top: 10,
                                left: 30,
                                right: 0
                            },
                            tooltip: {},
                            xAxis: {
                                data: [ <?php echo $chart_dates; ?> ]
                            },
                            yAxis: {},
                            series: [{
                                name: 'Anfragen',
                                type: 'line',
                                data: [ <?php echo $chart_data; ?> ],
                                color: '#0096ff'
                            }]
                        };
    
                        myChart.setOption(option);
                    </script>
                <?php
                return ob_get_clean();
    
            }
    
        }
    

        protected function render_fields( $id, $val, $fields ) {

            foreach( $fields as $field ) {
    
                $name = $field[ 'name' ];
                $group = $field[ 'group' ];
                $field_settings = array(
                    'id'        => "cf7val[". $id ."][". $group ."][" . $name . "]",
                    'group'     => $group,
                    'name'      => $name,
                    'class'     => 'cf7_' . $group . '_' . $name,
                    'list'      => '',
                    'readonly'  => $field[ 'readonly' ],
                    'val'       => $val[ $group ][ $name ],
                    'desc'      => $field[ 'desc' ]
                );
                if( $field[ 'list' ] )
                    $field_settings[ 'list' ] = $field[ 'list' ];
    
                switch( $field[ 'type' ] ) {
                    case 'input':
                        echo $this->cf7_event_tracker_get_input_field( $field_settings );
                    break;
                    case 'textarea':
                        echo $this->cf7_event_tracker_get_textarea_field( $field_settings );
                    break;
                    case 'checkbox':
                        echo $this->cf7_event_tracker_get_checkbox_field( $field_settings );
                    break;
                    case 'headline':
                        echo $this->cf7_event_tracker_get_headline( $field_settings );
                    break;
                    default: break;
                }
                
            }
    
        }

        public function get_cf7_tags_datalist( $cf7id ) {

            if( !empty( $cf7id ) ) {

                $form = \WPCF7_ContactForm::get_instance( $cf7id );

                ob_start();
                $form->suggest_mail_tags( 'mail' );
                $form_tags = ob_get_clean();

                preg_match_all( "'<span\W?(class=\"[^\"]*\")?>(.*?)</span>'si", $form_tags, $match );
                if( !empty( $match[2] ) ) {
                    
                    ob_start();
                    ?>
                        <datalist id="cf7_tag_list_<?php echo $cf7id; ?>">
                            <?php
                                foreach( $match[2] as $tag ) {
                                    ?>
                                        <option value="<?php echo preg_replace( '/(\[|\])/', '', $tag ); ?>"><?php echo $tag; ?></option>
                                    <?php
                                }
                            ?>
                        </datalist>
                    <?php
                    return ob_get_clean();

                }

                return "";

            }

        }

        #region Field-Type Functions
            protected function cf7_event_tracker_get_input_field( $args ) {

                $args = array(
                    'type'          => 'input',
                    'id'            => $args[ 'id' ],
                    'value'         => $args[ 'val' ],
                    'placeholder'   => $args[ 'desc' ][ 'placeholder' ],
                    'class'         => $args[ 'class' ],
                    'style'         => '',
                    'label'         => '',
                    'list'          => $args[ 'list' ],
                    'readonly'      => $args[ 'readonly' ],
                    'hint'          => array(
                        'title'         => $args[ 'desc' ][ 'title' ],
                        'description'   => $args[ 'desc' ][ 'description' ]
                    )
                );
                $field = new InputField( $args );
                return $field->get_field();

            }

            protected function cf7_event_tracker_get_textarea_field( $args ) {

                $args = array(
                    'type'          => 'textarea',
                    'id'            => $args[ 'id' ],
                    'value'         => $args[ 'val' ],
                    'placeholder'   => $args[ 'desc' ][ 'placeholder' ],
                    'class'         => $args[ 'class' ],
                    'style'         => 'height: 100px',
                    'label'         => '',
                    'list'          => $args[ 'list' ],
                    'readonly'      => $args[ 'readonly' ],
                    'hint'          => array(
                        'title'         => $args[ 'desc' ][ 'title' ],
                        'description'   => $args[ 'desc' ][ 'description' ]
                    )
                );
                $field = new InputField( $args );
                return $field->get_field();

            }

            protected function cf7_event_tracker_get_checkbox_field( $args ) {

                $args = array(
                    'type'          => 'checkbox',
                    'id'            => $args[ 'id' ],
                    'value'         => $args[ 'val' ],
                    'placeholder'   => $args[ 'desc' ][ 'placeholder' ],
                    'class'         => $args[ 'class' ],
                    'style'         => 'height: 100px',
                    'label'         => '',
                    'list'          => $args[ 'list' ],
                    'readonly'      => $args[ 'readonly' ],
                    'hint'          => array(
                        'title'         => $args[ 'desc' ][ 'title' ],
                        'description'   => $args[ 'desc' ][ 'description' ]
                    )
                );
                $field = new InputField( $args );
                return $field->get_field();

            }

            protected function cf7_event_tracker_get_headline( $args ) {

                ob_start();
                ?>
                    <div class="headline_wrapper">
                        <p>&nbsp;</p>
                        <h5>
                            <?php echo $args[ 'desc' ][ 'title' ]; ?>
                        </h5>
                        <?php
                            if( !empty( $args[ 'desc' ][ 'description' ] ) ) {
                                ?>
                                    <p><?php echo $args[ 'desc' ][ 'description' ]; ?></p>
                                <?php
                            }
                        ?>
                    </div>
                <?php
                return ob_get_clean();

            }
        #endregion

    }

?>