<?php

	namespace CF7EventTracker;

	class IncludeScripts {

		public function register_hooks() {

			add_action( 'wp_enqueue_scripts', array( $this, 'include_frontend_scripts' ) );
			add_action( 'wp_enqueue_style', array( $this, 'include_frontend_styles' ) );

			add_action( 'admin_enqueue_scripts', array( $this, 'include_backend_scripts' ) );
			add_action( 'admin_print_styles', array( $this, 'include_backend_styles' ) );

		}

		// Frontend
		public function include_frontend_scripts() {

			if( !wp_script_is( 'jquery', 'enqueued' ) ) {
				wp_register_script( 'jquery', CF7ET_URL . 'js/jquery.3.3.1.min.js', array( 'jquery' ) );
				wp_enqueue_script( 'jquery' );
			}
			wp_localize_script( 'jquery', 'ajax_object', array(
				'ajax_url'       => admin_url( 'admin-ajax.php' ),
				'ajax_nonce'     => wp_create_nonce( 'ajax-cf7et-nonce' ))
			);
	
			wp_register_script( 'cf7_ga_tracker_script', CF7ET_URL . 'js/script.js', array( 'jquery' ) );
			wp_enqueue_script( 'cf7_ga_tracker_script' );

		}

		public function include_frontend_styles() {

		}

		// Backend
		public function include_backend_scripts() {
			
			wp_localize_script( 'jquery', 'ajax_object', array(
				'ajax_url'       => admin_url( 'admin-ajax.php' ),
				'ajax_nonce'     => wp_create_nonce( 'ajax-cf7et-nonce' ))
			);
			
			wp_register_script( 'cf7_ga_tracker_admin_script', CF7ET_URL . 'js/admin.js', array( 'jquery' ) );
			wp_enqueue_script( 'cf7_ga_tracker_admin_script' );
			
			wp_register_script( 'echart_script', CF7ET_URL . 'js/echart.jquery.js', array( 'jquery' ) );
			wp_enqueue_script( 'echart_script' );

		}

		public function include_backend_styles() {

			wp_register_style( 'cf7_ga_admin_styles', CF7ET_URL . 'css/admin.css' );
			wp_enqueue_style( 'cf7_ga_admin_styles' );

		}

	}

?>