<?php

    namespace CF7EventTracker;

    class SettingsField {

        private $options;
        private $settings;
        private $fields;

        private $field;		// Object of type "InputField", "CheckboxField" or "DropdownField"

        private $title;		// Title in Field-Wrapper
        private $desc;		// Description aside of Input-Field or Checkbox
        private $addit;		// Additional Information beneath Label

        function __construct( $field, $args ) {

            $this->options = \get_option( 'cf7_ga_tracking' );
            $this->fields = $this->options[ 'fields' ];
            $this->settings = $this->options[ 'settings' ];

            $this->field	= $field;

            $this->title	= $args[ 'title' ] ?: '';
            $this->desc		= $args[ 'description' ] ?: '';
            $this->addit	= $args[ 'additional_info' ] ?: '';

        }

        public static function get_datalist( $args ) {

            $list_id	= $args[ 'list_id' ];	// ID of Datalist
            $list		= $args[ 'list' ];		// Array of Options in Datalist

            if( !is_array( $list ) )
                return false;

            ob_start();
            ?>
                <datalist id="<?php echo $list_id; ?>">
                    <?php
                        foreach( $list as $value => $label ) {
                            ?>
                                <option value="<?php echo $value; ?>"><?php echo $label; ?></option>
                            <?php
                        }
                    ?>
                </datalist>
            <?php
            return ob_get_clean();

        }

        public function get_field_area() {
            
            $field_class = get_class( $this->field );
            if( strpos( $field_class, 'InputField' ) == -1 )
                return false;

            return $this->setup_field();

        }

        private function setup_field() {

            ob_start();
            ?>
                <div class="row row-block">
                    <div class="col-12">
                        <h4><?php echo $this->title; ?></h4>
                    </div>
                    <div class="col-4">
                        <?php echo $this->field->get_field(); ?>
                    </div>
                    <div class="col-8">
                        <span><?php echo $this->desc; ?></span>
                        <?php echo $this->addit; ?>
                    </div>
                </div>
            <?php
            return ob_get_clean();

        }

    }

?>