<?php

    namespace CF7EventTracker;

    class Sidebar {

        public function get_sidebar_content() {
            
            $result = "";
            $result .= $this->get_plugin_sidebar_content();
            $result .= $this->get_general_sidebar_content();
            $result .= $this->get_sidebar_footer();
    
            return $result;

        }

        #region Content for specific Content in Sidebar
            private function get_plugin_sidebar_content() {

                $posts_details = array();
                if( empty( \get_transient( 'cf7_event_tracker-plugin_messages', array() ) ) ) {

                    $wp_json = 'https://update.codepalm.de/wp-json/plugin_posts/v1/cf7-event-tracker/';
                    $json = file_get_contents( $wp_json );
                    $posts_details = json_decode( $json, true );

                    if( !empty( $posts_details ) ) {

                        \set_transient( 'cf7_event_tracker-plugin_messages', $posts_details, 3600 );

                    }
            
                }
                else {

                    $posts_details = \get_transient( 'cf7_event_tracker-plugin_messages', array() );

                }

                if( empty( $posts_details ) || property_exists( $posts_details, 'error' ) ) {

                    $posts_details = array(
                        array(
                            'thumb'     => '#',
                            'link'      => '#',
                            'title'     => 'Fehler bei der Verbindung mit dem Message-Host',
                            'excerpt'   => 'Die Verbindung mit dem Message-Host konnte nicht hergestellt werden. Bitte warte ein wenig, oder kontaktiere <a href="mailto:info@codepalm.de">info@codepalm.de</a> falls der Fehler bereits länger auftritt.'
                        )
                    );

                }

                return $this->get_plugin_sidebar_posts( $posts_details );

            }

            private function get_plugin_sidebar_posts( $posts_details ) {

                $result = "";
                foreach( $posts_details as $post ) {

                    $result .= $this->replace_plugin_sidebar_placeholders(
                        $this->get_plugin_sidebar_structure(),
                        $this->get_plugin_sidebar_replacements( $post )
                    );

                }

                return $result;

            }

            private function get_plugin_sidebar_structure() {

                return '
                    <div>
                        %THUMB%
                        <h3>%TITLE%</h3>
                        <p>%EXCERPT%</p>
                        %LINK%
                    </div>
                ';

            }
            private function get_plugin_sidebar_replacements( $post ) {

                return array(
                    'LINK'      => $this->get_plugin_sidebar_link_structure(
                        \_x( 'Read More', 'Sidebar Content', 'cf7-event-tracker' ),
                        $post[ 'link' ],
                        "button"
                    ),
                    'THUMB'     => $this->get_plugin_sidebar_link_structure(
                        $post[ 'thumb' ],
                        "image",
                        $post[ 'link' ]
                    ),
                    'TITLE'     => $post[ 'title' ],
                    'EXCERPT'   => $post[ 'excerpt' ]
                );

            }
            private function get_plugin_sidebar_link_structure( $content, $link, $type="button", $class="" ) {

                if( empty( $link ) || $link == '#' || empty( $content ) || $content == '#' ) {
                    return "";
                }

                if( $type == "button" && strpos( $class, "button" ) === false ) {

                    $class .= " button";

                }
                else if( $type == "image" ) {

                    $content = "<img src='$content' width='100%' />";

                }

                if( !empty( $class ) ) {

                    $class = "class='$class'";

                }

                return "<a href='$link' target='_blank' $class>$content</a>";

            }

            private function replace_plugin_sidebar_placeholders( $structure, $replacements ) {

                foreach( $replacements as $placeholder => $replacement ) {

                    $placeholder = "%$placeholder%";
                    $structure = str_replace( $placeholder, $replacement, $structure );

                }

                return $structure;

            }
        #endregion

        #region General Content for Sidebar
            private function get_general_sidebar_content() {

                // ToDo: Setup general Content for the Sidebar

            }

            private function get_sidebar_footer() {

                return '
                    <div style="width: 100%; text-align: center;">
                        <a href="https://www.codepalm.de/" target="_blank">
                            <img src="' . CF7ET_URL . 'img/codepalm_logo.png" style="width: 50px;" />
                        </a>
                    </div>
                ';
        
            }
        #endregion

    }

?>