<?php

    namespace CF7EventTracker;

    abstract class cURLHandler {

        static public function callAPI( $method, $url, $data ) {
                    
            if( !in_array( 'curl', get_loaded_extensions() ) )
                return json_encode( array(
                    'status'	=> 'error',
                    'type'		=> 'CURL not available'
                ));
            
            $curl = curl_init();
            
            switch( $method ) {
                case "POST":
                    curl_setopt($curl, CURLOPT_POST, 1);
                    if( $data )
                        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
                    break;
                case "PUT":
                    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "PUT");
                    if ($data)
                        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
                break;
                default:
                    if( $data )
                        $url = sprintf("%s?%s", $url, http_build_query($data));
                break;
            }
            
            
            // OPTIONS:
            curl_setopt( $curl, CURLOPT_URL, $url );
            curl_setopt( $curl, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json'
            ));
            curl_setopt( $curl, CURLOPT_RETURNTRANSFER, 1 );
            curl_setopt( $curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC );
            
            // EXECUTE:
            $result = curl_exec( $curl );
            if( !$result ) {
                return json_encode( array(
                    'status'	=> 'error',
                    'type'		=> 'Connection refused'
                ));
            }
            curl_close( $curl );
            
            return json_encode( $result );
            
        }

    }

?>