<?php

	namespace CPPluginCore;

	if( !class_exists( '\CPPluginCore\IncludeScripts' ) ) {

		class IncludeScripts {

			private $plugin_url;

			public function register_hooks( $plugin_url="" ) {
				
				$this->plugin_url = $plugin_url;

				\add_action( 'wp_enqueue_scripts', array( $this, 'include_frontend_scripts' ) );
				\add_action( 'wp_enqueue_scripts', array( $this, 'include_frontend_styles' ) );

				\add_action( 'admin_enqueue_scripts', array( $this, 'include_backend_scripts' ) );
				\add_action( 'admin_print_styles', array( $this, 'include_backend_styles' ) );

			}

			// Frontend
			public function include_frontend_scripts() {

				\wp_register_script( 'cp-bootstrap_script', $this->plugin_url . '/vendor/codepalm/wp-plugin-core/js/bootstrap.js' );
				\wp_enqueue_script( 'cp-bootstrap_script' );

			}

			public function include_frontend_styles() {

				\wp_register_style( 'cp-addon-addon', $this->plugin_url . '/css/main.css' );
				\wp_enqueue_style( 'cp-addon-addon' );

			}

			// Backend
			public function include_backend_scripts() {
				
			}

			public function include_backend_styles() {

				\wp_register_style( 'admin_styles', $this->plugin_url . '/css/admin.css' );
				\wp_enqueue_style( 'admin_styles' );

			}

		}

	}

?>
