<?php

    namespace CPPluginCore;

    if( !class_exists( '\CPPluginCore\File' ) ) {

        class File {

            public $path;
            public $load_in;
            public $required;
            private $callback;

            function __construct( $path, $load_in, $required=false, $callback=null ) {

                $this->path = $path;
                $this->load_in = $load_in;
                $this->required = $required;
                $this->callback = $callback;

            }

            public function loadFile( $page ) {

                if( $page == -1 || $this->load_in == -1 || in_array( $page, $this->load_in ) )
                    return $this->path;
                else 
                    return false;

            }

            public function fileIsRequired() {

                return $this->required;

            }

            public function triggerCallback() {

                if( !empty( $this->callback ) && is_callable( $this->callback ) ) {
                    ( $this->callback )();
                }
                
            }

        }

    }

?>
